﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Microsoft.Win32;
using System.IO;
using System.Diagnostics;
using System.Windows.Threading;
using System.Windows.Controls.Primitives;

// http://www.cdsy.de/Projekte/mp3_flac/flac/start_flac.html
// http://www.cdsy.de/Projekte/mp3_flac/flac/flac_STREAMINFO.html


// Links
//   https://docs.microsoft.com/en-us/windows/communitytoolkit/controls/wpf-winforms/mediaplayerelement
//   https://docs.microsoft.com/en-us/dotnet/desktop/wpf/graphics-multimedia/how-to-control-a-mediaelement-play-pause-stop-volume-and-speed?view=netframeworkdesktop-4.8
// myMediaElement.Volume = (double)volumeSlider.Value;

using AudioPlayer.Tools;
using System.Net;

using System.Text;
//using System.Text.Json.Serialization;

namespace AudioPlayer {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        private String dialogname = "MainWindow";
        private int fontsize = 14;

        private MediaPlayer mediaPlayer = null;


        

        private List<FileItem> fileliste = new List<FileItem>();
        private int listviewSelectedIndex = -1;

        private String albumname = "???????????";
        private bool userIsDraggingSlider = false;
        private bool mediaPlayerIsPlaying = false;

        private bool audioLaenge = false;
        private String labelTitleContent = "";


        private bool isSmallView = false;
        private GridLength columndefTree;
        private GridLength rowdefListview;
        private double actualHeightOri = 0;
        private double actualWidthOri = 0;

        private AudioColors audioColors = null;

        public MainWindow() {
            InitializeComponent();

        }

        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            bnStartSearchFiles.IsEnabled = false;
            String path = SingVar.LastPath;


            CommandBindings.Add(new CommandBinding(MyCommands.Dos, DosExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Rename, RenameExecuted, RenameCheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Find, FindExecuted, CheckCanExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.Skip_previous, Skip_previousExecuted, PlayCheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Previoustime, PrevioustimeExecuted, PlayCheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Play, PlayExecuted, Play_CanExecute));
            CommandBindings.Add(new CommandBinding(MyCommands.Stop, StopExecuted, Pause_Stop_CanExecute));
            CommandBindings.Add(new CommandBinding(MyCommands.Pause, PauseExecuted, Pause_Stop_CanExecute));
            CommandBindings.Add(new CommandBinding(MyCommands.Nexttime, NexttimeExecuted, PlayCheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Skip_next, Next_previousExecuted, PlayCheckCanExecuted));

            labelSpeaker.Visibility = Visibility.Collapsed;
            sliderSpeaker2.Visibility = Visibility.Collapsed;

            this.fontsize = SingVar.Fontsize;
            setFontsizeRegistry(this.fontsize);

            audioColors = new AudioColors(SingVar.ColorMode);
            audioColors.loadFromRegistry();
            setColors();


            Basis.setWindowPositionFromRegistry(this, SingVar.C_REG_ADR, dialogname);
            if (Directory.Exists(path) || (path.IndexOf(";") > 0)) {
                bnStartSearchFiles.IsEnabled = true;
                tPath.Text = path;
                bnStartSearchFiles_Click(null, null);
            }
            DispatcherTimer timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromSeconds(0.1);
            timer.Tick += timer_Tick;
            timer.Start();

            sliderSpeaker.Minimum = 0;
            sliderSpeaker.Maximum = 1;

            sliderSpeaker2.Minimum = 0;
            sliderSpeaker2.Maximum = 1;

            mediaPlayer = new MediaPlayer();
            mediaPlayer.MediaEnded += MediaPlayer_MediaEnded;

            //mediaplayer.
            sliderSpeaker.Value = mediaPlayer.Volume;
            sliderSpeaker2.Value = mediaPlayer.Volume;


            //var request = WebRequest.Create("http://miwilhelm.de/php/getRangePur.php");
            //request.ContentType = "application/json; charset=utf-8";

            //string text;
            //var response = (HttpWebResponse)request.GetResponse();

            //using (var sr = new StreamReader(response.GetResponseStream())) {
            //    String jsonString = sr.ReadToEnd();
            //    tPath.Text = jsonString;
            //    // var jsonString = JsonSerializer.Serialize(yourObject);

            //    //RangeJson rangejson = (RangeJson)JavaScriptConvert.DeserializeObject(Request[jonsstring], typeof(RangeJson));

            //    // Deserialize
            //    //var obj = JsonSerializer.Deserialize<RangeJson>(jonsstring);
            //   // RangeJson rangejson = JsonSerializer.Deserialize<RangeJson>(jsonString);

            //}

        }

        [Serializable]
        class RangeJson {

            public int range { get; set; }
            public string error { get; set; }
            public bool isError { get; set; }
        }

        private void MediaPlayer_MediaEnded(Object sender, EventArgs e) {
            Next_previousExecuted(null, null);
        }


        private void setFontsize(int fontsize) {
            this.fontsize = fontsize;
            SingVar.Fontsize = fontsize;
            toolbar1.FontSize = fontsize;
            mainMenu.FontSize = fontsize;
            this.LPath.FontSize = fontsize;
            this.tPath.FontSize = fontsize;
            this.tree.FontSize = fontsize;
            this.listview.FontSize = fontsize;
            labelAlbum.FontSize = fontsize;
            labelTitle.FontSize = fontsize;
            labelArtist.FontSize = fontsize;
            labelTotalTime.FontSize = fontsize;
            labelSamplerate.FontSize = fontsize;
            labelSpeaker.FontSize = fontsize;

        }

        private void Window_PreviewMouseWheel(Object sender, MouseWheelEventArgs e) {
            if (Keyboard.Modifiers.HasFlag(ModifierKeys.Control)) {
                //Title = e.Delta.ToString();
                e.Handled = true;
                if (e.Delta > 0) {
                    fontsize += 2;
                    if (fontsize > 58) fontsize = 58;
                }
                else {
                    fontsize -= 2;
                    if (fontsize < 8) fontsize = 8;
                }
                this.setFontsize(fontsize);
            }
        }
        private void clearFontMenues(object sender) {
            mnFont8pg.IsChecked = false;
            mnFont10pg.IsChecked = false;
            mnFont12pg.IsChecked = false;
            mnFont14pg.IsChecked = false;
            mnFont16pg.IsChecked = false;
            mnFont18pg.IsChecked = false;
            mnFont20pg.IsChecked = false;
            mnFont24pg.IsChecked = false;
            mnFont28pg.IsChecked = false;

            mnFont30pg.IsChecked = false;
            mnFont32pg.IsChecked = false;
            mnFont34pg.IsChecked = false;
            mnFont36pg.IsChecked = false;
            mnFont38pg.IsChecked = false;
            mnFont40pg.IsChecked = false;
            mnFont42pg.IsChecked = false;
            mnFont44pg.IsChecked = false;
            mnFont46pg.IsChecked = false;
            mnFont48pg.IsChecked = false;
            mnFont50pg.IsChecked = false;
            mnFont52pg.IsChecked = false;
            mnFont54pg.IsChecked = false;
            mnFont56pg.IsChecked = false;
            mnFont58pg.IsChecked = false;
            MenuItem mnItem = (MenuItem)sender;
            mnItem.IsChecked = true;
        }
        private void setFontsizeRegistry(int fs) {
            if (fs == 8) {
                mnFont8pg.IsChecked = true;
                clearFontMenues(mnFont8pg);
                setFontsize(8);
            }
            if (fs == 10) {
                mnFont10pg.IsChecked = true;
                clearFontMenues(mnFont10pg);
                setFontsize(10);
            }
            if (fs == 12) {
                mnFont12pg.IsChecked = true;
                clearFontMenues(mnFont12pg);
                setFontsize(12);
            }
            if (fs == 14) {
                mnFont14pg.IsChecked = true;
                clearFontMenues(mnFont14pg);
                setFontsize(14);
            }
            if (fs == 16) {
                mnFont16pg.IsChecked = true;
                clearFontMenues(mnFont16pg);
                setFontsize(16);
            }
            if (fs == 18) {
                mnFont18pg.IsChecked = true;
                clearFontMenues(mnFont18pg);
                setFontsize(18);
            }
            if (fs == 20) {
                mnFont20pg.IsChecked = true;
                clearFontMenues(mnFont20pg);
                setFontsize(20);
            }
            if (fs == 22) {
                mnFont22pg.IsChecked = true;
                clearFontMenues(mnFont22pg);
                setFontsize(22);
            }
            if (fs == 24) {
                mnFont24pg.IsChecked = true;
                clearFontMenues(mnFont24pg);
                setFontsize(24);
            }
            if (fs == 26) {
                mnFont26pg.IsChecked = true;
                clearFontMenues(mnFont26pg);
                setFontsize(26);
            }
            if (fs == 28) {
                mnFont28pg.IsChecked = true;
                clearFontMenues(mnFont28pg);
                setFontsize(28);
            }
            if (fs == 30) {
                mnFont30pg.IsChecked = true;
                clearFontMenues(mnFont30pg);
                setFontsize(30);
            }
            if (fs == 32) {
                mnFont32pg.IsChecked = true;
                clearFontMenues(mnFont32pg);
                setFontsize(32);
            }
            if (fs == 34) {
                mnFont34pg.IsChecked = true;
                clearFontMenues(mnFont34pg);
                setFontsize(34);
            }
            if (fs == 36) {
                mnFont36pg.IsChecked = true;
                clearFontMenues(mnFont36pg);
                setFontsize(36);
            }
            if (fs == 38) {
                mnFont38pg.IsChecked = true;
                clearFontMenues(mnFont38pg);
                setFontsize(38);
            }
            if (fs == 40) {
                mnFont40pg.IsChecked = true;
                clearFontMenues(mnFont40pg);
                setFontsize(40);
            }
            if (fs == 42) {
                mnFont42pg.IsChecked = true;
                clearFontMenues(mnFont42pg);
                setFontsize(42);
            }
            if (fs == 44) {
                mnFont44pg.IsChecked = true;
                clearFontMenues(mnFont44pg);
                setFontsize(44);
            }
            if (fs == 46) {
                mnFont46pg.IsChecked = true;
                clearFontMenues(mnFont46pg);
                setFontsize(46);
            }
            if (fs == 48) {
                mnFont48pg.IsChecked = true;
                clearFontMenues(mnFont48pg);
                setFontsize(48);
            }
            if (fs == 50) {
                mnFont50pg.IsChecked = true;
                clearFontMenues(mnFont50pg);
                setFontsize(50);
            }
            if (fs == 52) {
                mnFont52pg.IsChecked = true;
                clearFontMenues(mnFont42pg);
                setFontsize(52);
            }
            if (fs == 54) {
                mnFont54pg.IsChecked = true;
                clearFontMenues(mnFont44pg);
                setFontsize(54);
            }
            if (fs == 56) {
                mnFont56pg.IsChecked = true;
                clearFontMenues(mnFont46pg);
                setFontsize(56);
            }
            if (fs == 58) {
                mnFont58pg.IsChecked = true;
                clearFontMenues(mnFont48pg);
                setFontsize(58);
            }
        }

        private void mnFont_Click(object sender, RoutedEventArgs e) {
            MenuItem mn = (MenuItem)sender;
            clearFontMenues(sender);
            setFontsize(Convert.ToInt32(mn.Tag));
        }

        private void DosExecuted(object sender, ExecutedRoutedEventArgs e) {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "CMD.exe";
            Prog.StartInfo.Arguments = "";
            Prog.StartInfo.WorkingDirectory = Basis.getProgPath();
            Prog.Start();
        }


        private void bnOpenDirectory_Click(Object sender, RoutedEventArgs e) {
            WSelectDirectory dialog = new WSelectDirectory(this, "Select an audio-folder", Basis.getProgPath());
            dialog.ShowDialog();
            if (dialog.Retcode) {
                tPath.Text = dialog.SelectDirectory;
                SingVar.LastPath = tPath.Text;
            }
        }

        private void bnAddDirectory_Click(Object sender, RoutedEventArgs e) {
            WSelectDirectory dialog = new WSelectDirectory(this, "Select an audio-folder", Basis.getProgPath());
            dialog.ShowDialog();
            if (dialog.Retcode) {
                if (tPath.Text.Length == 0) {
                    tPath.Text = dialog.SelectDirectory;
                    SingVar.LastPath = tPath.Text;
                }
                else {
                    tPath.Text += ";" + dialog.SelectDirectory;
                    SingVar.LastPath = tPath.Text;
                }
            }
        }



        private void bnStartSearchFiles_Click(Object sender, RoutedEventArgs e) {
            TreeViewItem root;
            tree.Items.Clear();
            String paths = tPath.Text.Trim();
            String[] lines = null;
            if (paths.IndexOf(";") > 0) {
                string[] splitStrings = { ";" };
                lines = paths.Split(splitStrings, StringSplitOptions.None);
            }
            else {
                lines = new String[1];
                lines[0] = paths;
            }

            foreach (String path in lines) {
                if (!Directory.Exists(path)) {
                    Basis.Message("The path to the audio-files are not exists\r\nPath: " + path, "Error");
                    continue;
                }
                root = new TreeViewItem();
                root.Header = path;
                root.Foreground = audioColors.brushTreeNodeCaptionFG;
                root.FontWeight = FontWeights.Bold;
                root.IsExpanded = true;
                tree.Items.Add(root);

                insertDirectories(root, path, 1);
            }
        }
        // L:\Aurender\classic;L:\Aurender\pop

        private void insertDirectories(TreeViewItem root, String path, int step) {
            if (!path.EndsWith("\\")) {
                path += "\\";
            }
            String[] directories = Directory.GetDirectories(path, "*.*", SearchOption.TopDirectoryOnly);
            foreach (String directoryname in directories) {
                FileInfo fi = new FileInfo(directoryname);
                int anzFiles = 0;
                foreach (String audiofiletyp in SingVar.listeMasks) {
                    String[] files = Directory.GetFiles(path + fi.Name, "*"+audiofiletyp, SearchOption.AllDirectories);
                    anzFiles += files.Length;
                }
                //long filesize = fi.Length;
                if (anzFiles > 0) {
                    TreeViewItem node = insertNode(root, new TreeFolder(fi.Name, fi.FullName, anzFiles), step);
                    insertDirectories(node, fi.FullName, step + 1);
                }
            }

        }  // bnStartSearchFiles_Click

        private TreeViewItem insertNode(TreeViewItem parent, TreeFolder folder, int step) {
            TreeViewItem node = new TreeViewItem();
            if (folder.anzahlFiles > 0)
                node.Header = " - " + folder.caption + " (" + folder.anzahlFiles + ")";
            else
                node.Header = " - " + folder.caption;
            node.Tag = folder;
            switch (step) {
                case 1:
                    node.Foreground = audioColors.brushTreeNode1FG;
                    node.Background = audioColors.brushTreeNode1BG;
                    node.FontWeight = FontWeights.Medium;
                    break;
                case 2:
                    node.Foreground = audioColors.brushTreeNode2FG;
                    node.Background = audioColors.brushTreeNode2BG;
                    node.FontWeight = FontWeights.DemiBold;
                    break;
                case 3:
                    node.Foreground = audioColors.brushTreeNode3FG;
                    node.Background = audioColors.brushTreeNode3BG;
                    node.FontWeight = FontWeights.Normal;
                    break;
                default:
                    node.Foreground = audioColors.brushTreeNode2FG;
                    node.Background = audioColors.brushTreeNode2BG;
                    node.FontWeight = FontWeights.DemiBold;
                    break;
            }

            parent.Items.Add(node);
            return node;
        }
        private void tree_SelectedItemChanged(Object sender, RoutedPropertyChangedEventArgs<Object> e) {
            TreeViewItem node = (TreeViewItem)tree.SelectedItem;
            if (node != null) {
                TreeFolder folder = (TreeFolder)node.Tag;
                albumname = folder.caption;
                fileliste.Clear();
                DirectoryInfo mainDir = new DirectoryInfo(folder.fullpath);
                foreach (String audiofiletyp in SingVar.listeMasks) {
                    FileInfo[] files = mainDir.GetFiles("*" + audiofiletyp, SearchOption.TopDirectoryOnly);
                    foreach (FileInfo fileinfo in files) {
                        FileItem fileitem = new FileItem(fileinfo);
                        fileliste.Add(fileitem);
                    }
                }
                listview.ItemsSource = null; ;
                listview.ItemsSource = fileliste;
            }
        }


        private void listview_MouseDoubleClick(Object sender, MouseButtonEventArgs e) {
            if (SingVar.ListviewSingleClick) {

            }
            else {  
                listView_PlkayAudioFile();
            }

        }
        private void listView_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
            if (SingVar.ListviewSingleClick) {
                listView_PlkayAudioFile();
            }
            else {

            }
        }

        private void listView_PlkayAudioFile() {

            listviewSelectedIndex = listview.SelectedIndex;
            FileItem fileitem = (FileItem)listview.SelectedItem;
            if (fileitem != null) {
                labelAlbum.Content = albumname.Replace("_", "__");

                labelTitleContent = fileitem.Filename.Replace("_", "__");
                labelTitle.Content = labelTitleContent;

                labelTotalTime.Content = "";
                if (fileitem.Fullname.ToLower().EndsWith(".flac")) {
                    Flac flac = new Flac(fileitem.Fullname);

                    if (flac.readSamplerate()) {
                        decimal fs = flac.samplerate;
                        fs /= 1000.0m;
                        labelSamplerate.Content = "Sampling-Rate: " + (fs).ToString("0.0") + " kHz  Bits: " + flac.bitcount;
                        labelTotalTime.Content = "TotalTime:      (" + flac.minutes.ToString("00") + ":" + flac.seconds.ToString("00") + ")";
                    }
                    if (flac.readTexte()) {
                        labelAlbum.Content = flac.album + " ";
                        labelArtist.Content = flac.artist;
                        labelTitle.Content = flac.title;
                        labelTitleContent = flac.title;
                    }

                }
                else {
                    if (fileitem.Fullname.ToLower().EndsWith(".wav")) {
                        Wave wave = new Wave(fileitem.Fullname);
                        wave.readSamplerate();
                        decimal fs = wave.samplerate;
                        fs /= 1000.0m;
                        labelSamplerate.Content = "Sampling-Rate: " + (fs).ToString("0.0") + " kHz  Bits: " + wave.bitcount;
                    }
                    else {
                        labelSamplerate.Content = "Sampling-Rate unbekannt";  // mp3 ??
                    }
                }

                // mediaPlayer.Source = new Uri(fileitem.Fullname);
                mediaPlayer.Open(new Uri(fileitem.Fullname));
                Duration duration = mediaPlayer.NaturalDuration;


                audioLaenge = false;
                PlayExecuted(null, null);
            }
        }

        private void mnWebRange_Click(object sender, RoutedEventArgs e) {
            if (mnWebRange.IsChecked) {
                mnWebRange.IsChecked = false;
            }
            else {
                mnWebRange.IsChecked = true;
            }
        }

        private void timer_Tick(object sender, EventArgs e) {
            int min, sec;
            TimeSpan tspan;

            if (mnWebRange.IsChecked == true) {
                var request = WebRequest.Create("http://miwilhelm.de/php/getRangePur.php");
                request.ContentType = "application/json; charset=utf-8";

                string text;
                var response = (HttpWebResponse)request.GetResponse();

                using (var sr = new StreamReader(response.GetResponseStream())) {
                    String jsonString = sr.ReadToEnd();
                    uint value = 0;
                    if (uint.TryParse(jsonString,out value)) {
                        double range = value / 100.0;
                        if (range != sliderSpeaker.Value) {
                            sliderSpeaker.Value = range;
                            mediaPlayer.Volume = sliderSpeaker.Value;
                        }
                    }
                }
                
            }
            


            if ((mediaPlayer.Source != null) && (mediaPlayer.NaturalDuration.HasTimeSpan) && (!userIsDraggingSlider)) {
                //sliderProgess.Minimum = 0;                
                sliderProgess.Maximum = mediaPlayer.NaturalDuration.TimeSpan.TotalSeconds;
                sliderProgess.Value = mediaPlayer.Position.TotalSeconds;
                if (!audioLaenge) {
                    tspan = mediaPlayer.NaturalDuration.TimeSpan;
                    min = (int)(tspan.Minutes);
                    sec = (int)(tspan.Seconds);
                    if (labelTotalTime.Content.ToString().Length == 0) {
                        labelTotalTime.Content = "(" + min.ToString("00") + ":" + sec.ToString("00") + ")";
                    }
                    audioLaenge = true;
                }
                tspan = mediaPlayer.Position;
                min = (int)(tspan.Minutes);
                sec = (int)(tspan.Seconds);
                labelTime.Content = min.ToString("00") + ":" + sec.ToString("00");
            }
        }
        private void sliderProgess_ValueChanged(Object sender, RoutedPropertyChangedEventArgs<Double> e) {
            if (audioLaenge) {
            }
        }

        private void PrevioustimeExecuted(Object sender, ExecutedRoutedEventArgs e) {
            double actualseconds = sliderProgess.Value;
            actualseconds -= 15;
            if (actualseconds < 0) {
                actualseconds = +5;
            }
            TimeSpan tspan = new TimeSpan(0, 0, (int)actualseconds);  // hour min sec
            mediaPlayer.Pause();
            mediaPlayer.Position = tspan;
            mediaPlayer.Play();
        }

        private void NexttimeExecuted(Object sender, ExecutedRoutedEventArgs e) {
            double actualseconds = sliderProgess.Value;
            actualseconds += 15;
            if (actualseconds> sliderProgess.Maximum) {
                actualseconds = sliderProgess.Maximum - 5;
            }

            TimeSpan tspan = new TimeSpan(0, 0, (int)actualseconds);  // hour min sec
            mediaPlayer.Pause();
            mediaPlayer.Position = tspan;
            mediaPlayer.Play();
        }


        private void sliderProgess_MouseUp(Object sender, MouseButtonEventArgs e) {
            if (e.LeftButton == MouseButtonState.Released && e.ClickCount == 1) {
                Point p = e.GetPosition(sliderProgess);
                double x = p.X;

                double width = sliderProgess.ActualWidth;
                double maxseconds = mediaPlayer.NaturalDuration.TimeSpan.TotalSeconds;
                double position = x * maxseconds / width;
                Title = "x: " + x + "  position: " + position + "  maxseconds: " + maxseconds;
                TimeSpan tspan = new TimeSpan(0, 0, (int)position);  // hour min sec



                mediaPlayer.Pause();
                mediaPlayer.Position = tspan;
                mediaPlayer.Play();


            }
        }

        private void sliderSpeaker_ValueChanged(Object sender, RoutedPropertyChangedEventArgs<Double> e) {
            mediaPlayer.Volume = sliderSpeaker.Value;
        }

        private void sliderSpeaker2_ValueChanged(Object sender, RoutedPropertyChangedEventArgs<Double> e) {
            mediaPlayer.Volume = sliderSpeaker2.Value;
        }


        private void Play_CanExecute(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = (mediaPlayer != null) && (mediaPlayer.Source != null);
        }
        private void Pause_Stop_CanExecute(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = mediaPlayerIsPlaying;
        }


        private void RenameCheckCanExecuted(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = listview.SelectedIndex >= 0;
        }
        private void PlayCheckCanExecuted(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = tree.Items.Count > 0;
        }


        private void PauseExecuted(Object sender, ExecutedRoutedEventArgs e) {
            mediaPlayer.Pause();
            mediaPlayerIsPlaying = false;
        }

        private void StopExecuted(Object sender, ExecutedRoutedEventArgs e) {
            mediaPlayer.Stop();
            mediaPlayerIsPlaying = false;
        }

        private void PlayExecuted(Object sender, ExecutedRoutedEventArgs e) {
            mediaPlayer.Play();
            mediaPlayerIsPlaying = true;
        }

        private void Skip_previousExecuted(Object sender, ExecutedRoutedEventArgs e) {
            try {
                if (listviewSelectedIndex > 0) {
                    listview.SelectedIndex = listviewSelectedIndex - 1; ;
                    listView_PlkayAudioFile();
                }
            }
            catch (Exception err) {
                Basis.ErrorMsg("Error: " + err.ToString(), "Error");
            }
        }

   

        private void Next_previousExecuted(Object sender, ExecutedRoutedEventArgs e) {
            try {
                if (listviewSelectedIndex < (fileliste.Count - 1)) {
                    listview.SelectedIndex = listviewSelectedIndex + 1; ;
                    listView_PlkayAudioFile();
                }        
            }
            catch (Exception err) {
                Basis.ErrorMsg("Error: " + err.ToString(), "Error");
            }
        }

        private void CheckCanExecuted(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = tree.Items.Count > 0;
        }

     
        private void RenameExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (listview.SelectedIndex >= 0) {
                mediaPlayer.Stop();
                FileItem fileitem = (FileItem)listview.SelectedItem;
                String path, filename;
                Basis.splitFilename(fileitem.Fullname, out path, out filename);
                WRenameFile dialog = new WRenameFile(this, filename);
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    String newfile = dialog.tNewname.Text.Trim();
                    String newFilename;
                    if (newfile.IndexOf("\\") >= 0)
                        newFilename = newfile;
                    else
                        newFilename = path + newfile;
                    System.IO.File.Move(fileitem.Fullname, newFilename);
                }
            }
        }

        private void FindExecuted(object sender, ExecutedRoutedEventArgs e) {
            WCreateSearchLIst dialog = new WCreateSearchLIst(this, tPath.Text);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                List<FileItem> playList = dialog.playList;
                fileliste.Clear();
                foreach (FileItem fileitem in playList) {
                    fileliste.Add(fileitem);
                }
                listview.ItemsSource = null; ;
                listview.ItemsSource = fileliste;
            }
        }

       

        private void setColors() {

            this.Background = audioColors.brushBG;

            mainMenu.Background = audioColors.brushMenubarBG;
            mainMenu.Foreground = audioColors.brushMenubarFG;

            foreach(Object obj in mainMenu.Items) {
                if (obj is MenuItem) {
                    MenuItem mn = (MenuItem)obj;
                    String h1 = (String) mn.Header;
                    mn.Background = audioColors.brushMenubarBG;
                    mn.Foreground = audioColors.brushMenubarFG;
                    foreach (Object obj2 in mn.Items) {
                        if (obj2 is MenuItem) {                            
                            MenuItem mn2 = (MenuItem)obj2;
                            String h2 = (String)mn2.Header;
                            mn2.Background = audioColors.brushMenubarBG;
                            mn2.Foreground = audioColors.brushMenubarFG;
                        }
                    }
                }
            }

            toolBarTray1.Background = audioColors.brushToolbarTextBoxBG;
            toolbar1.Background = audioColors.brushToolbarTextBoxBG;
            toolbar1.Foreground = audioColors.brushToolbarTextBoxFG;
            LPath.Foreground = audioColors.brushToolbarLabelFG;
            tPath.Foreground = audioColors.brushToolbarTextBoxFG;
            tPath.Background = audioColors.brushToolbarTextBoxBG;

            this.tree.Background = audioColors.brushTreeBG;

            this.listview.Background = audioColors.brushListviewBG;
            this.listview.Foreground = audioColors.brushListviewFG;

            sliderProgess.Background = audioColors.brushBG;

            labelTime.Background = audioColors.brushTimeBG;
            labelTime.Foreground = audioColors.brushTimeFG;

            PlayerDockpanel.Background = audioColors.brushPlayPanelBG;
            labelAlbum.Foreground = audioColors.brushAlbumFG;
            labelArtist.Foreground = audioColors.brushArtistFG;
            labelTitle.Foreground = audioColors.brushTitleFG;

            labelTotalTime.Foreground = audioColors.brushSamplerateFG;
            labelSamplerate.Foreground = audioColors.brushSamplerateFG;
            labelSpeaker.Foreground = audioColors.brushSamplerateFG;

        }

        private void setColorsListView() {
            setColors();
            fileliste.Clear();
            listview.ItemsSource = null;
            bnStartSearchFiles_Click(null, null);
        }

        private void mnLightModus1_Click(Object sender, RoutedEventArgs e) {
            this.audioColors = new AudioColors(AudioColors.ColorTyp.LIGHTMODE1);
            this.audioColors.save2Registry();
            SingVar.ColorMode = AudioColors.ColorTyp.LIGHTMODE1;
            setColorsListView();
        }
        private void mnLightModus2_Click(Object sender, RoutedEventArgs e) {
            this.audioColors = new AudioColors(AudioColors.ColorTyp.LIGHTMODE2);
            this.audioColors.save2Registry();
            SingVar.ColorMode = AudioColors.ColorTyp.LIGHTMODE2;
            setColorsListView();
        }

        private void mnDarkModus1_Click(Object sender, RoutedEventArgs e) {
            this.audioColors = new AudioColors(AudioColors.ColorTyp.DARKMODE1);
            SingVar.ColorMode = AudioColors.ColorTyp.DARKMODE1;
            this.audioColors.save2Registry();
            setColorsListView();
        }
        private void mnDarkModus2_Click(Object sender, RoutedEventArgs e) {
            this.audioColors = new AudioColors(AudioColors.ColorTyp.DARKMODE2);
            SingVar.ColorMode = AudioColors.ColorTyp.DARKMODE1;
            this.audioColors.save2Registry();
            setColorsListView();
        }

        private void mnLoadColors_Click(Object sender, RoutedEventArgs e) {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "Text-File (*.txt)|*.txt|" + "All files (*.*)|*.*";

            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".txt";
            openFileDialog1.InitialDirectory = System.Environment.CurrentDirectory;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            openFileDialog1.Title = "Open colorfile";

            if (openFileDialog1.ShowDialog() == true) {
                this.audioColors.loadfile(openFileDialog1.FileName.ToString());
                this.audioColors.loadFromRegistry();
                setColorsListView();
            }            // this.audioColors
        }

        private void mnSaveColors_Click(Object sender, RoutedEventArgs e) {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "Color File (*.txt)|*.txt|Alle Dateien (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".txt";
            saveFileDialog1.Title = "Save colorfile";
            saveFileDialog1.InitialDirectory = System.Environment.CurrentDirectory;
            saveFileDialog1.RestoreDirectory = true;
            if (saveFileDialog1.ShowDialog() == true) {
                this.audioColors.savefile(saveFileDialog1.FileName.ToString());
                setColorsListView();
            }
        }
        private void mnShowPlaylists_Click(Object sender, RoutedEventArgs e) {

        }

        private void mnAdPlaylists_Click(Object sender, RoutedEventArgs e) {

        }


        private void bnFullscreen_Click(Object sender, RoutedEventArgs e) {

        }

        private void mnOptions_Click(Object sender, RoutedEventArgs e) {
            WOptions dialog = new WOptions(this, this.audioColors);
            dialog.ShowDialog();
            if (dialog.Result) {
                this.audioColors.loadFromRegistry();
                setColors();
            }
        }

        private void mnProgInfo_Click(Object sender, RoutedEventArgs e) {
            WProgInfo dialog = new WProgInfo(this);
            dialog.ShowDialog();
        }

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            Basis.writeWindowPosition2Registry(this, SingVar.C_REG_ADR, dialogname);
        }

        private void mnClose_Click(Object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_PreviewKeyDown(Object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Escape) && isSmallView) {
                bnSmallView_Click(sender, null);
            }
        }

        private void bnSmallView_Click(Object sender, RoutedEventArgs e) {
            if (isSmallView) {
                mainMenu.Visibility = Visibility.Visible;
                toolBarTray1.Visibility = Visibility.Visible;
                // tree.Visibility = Visibility.Visible;
                listview.Visibility = Visibility.Visible;
                ColumnDefinitionCollection colldef = gridsplitContainer1.ColumnDefinitions;
                GridLength gl = new GridLength(0);
                colldef[0].Width = columndefTree;

                RowDefinitionCollection rowdefs = gridsplitContainer1.RowDefinitions;
                RowDefinition rowdef = rowdefs[0];  // ListView
                rowdef.Height = rowdefListview;

                this.Height = actualHeightOri;
                this.Width = actualWidthOri;

                labelSpeaker.Visibility = Visibility.Collapsed;
                sliderSpeaker2.Visibility = Visibility.Collapsed;

                sliderSpeaker.Value = sliderSpeaker2.Value;

                isSmallView = false;
                
            }
            else {
                mainMenu.Visibility = Visibility.Collapsed;
                toolBarTray1.Visibility = Visibility.Collapsed;
                //tree.Visibility = Visibility.Collapsed;
                //listview.Visibility = Visibility.Collapsed;
                ColumnDefinitionCollection colldef = gridsplitContainer1.ColumnDefinitions;
                GridLength gl = new GridLength(0);
                columndefTree = colldef[0].Width;
                colldef[0].Width = gl;

                RowDefinitionCollection rowdefs = gridsplitContainer1.RowDefinitions;
                RowDefinition rowdef = rowdefs[0];  // ListView
                gl = rowdef.Height;
                rowdefListview = gl;

                actualHeightOri = this.ActualHeight;
                actualWidthOri = this.ActualWidth;
                this.Height = 600;
                this.Width = 550;

                labelSpeaker.Visibility = Visibility.Visible;
                sliderSpeaker2.Visibility = Visibility.Visible;
                sliderSpeaker2.Value = sliderSpeaker.Value;

                //rowdefs[0].Height = new GridLength(0); ;

                // UIElementCollection coll = gridsplitContainer1.Children;


                //ColumnDefinitionCollection cols = splitContainer1.ColumnDefinitions;
                //if (mnProfi.IsChecked) {
                //    GridLength gl1 = new GridLength(0);
                //    bnStandard.Content = "Standard";
                //    cols[0].Width = gl1;
                //    mnProfi.IsChecked = !mnProfi.IsChecked;
                //}

                isSmallView = true;
            }
        }

    }
}
