﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Collections;
using AudioPlayer.Tools;

namespace AudioPlayer {
    public class SingVar {

        public static string C_REG_ADR = "SOFTWARE\\WILHELM\\AudioPlayer";
        public static string C_REG_ADR_COLORS = "SOFTWARE\\WILHELM\\AudioPlayer\\COLORS";

        private static String lastPath = "";

        public static String LastPath {
            get { return lastPath; }
            set {
                lastPath = value;
                Basis.WriteRegString(C_REG_ADR, "lastPath", lastPath);
            }
        }

        

        private static int fontsize = 14;
        public static int Fontsize {
            get { return fontsize; }
            set {
                fontsize = value;
                Basis.WriteRegInt(C_REG_ADR, "fontsize", fontsize);
            }
        }

        private static AudioColors.ColorTyp colormode = AudioColors.ColorTyp.LIGHTMODE1;
        public static AudioColors.ColorTyp ColorMode {
            get { return colormode; }
            set {
                colormode = value;
                Basis.WriteRegInt(C_REG_ADR, "lightmode", (int)colormode);
            }
        }
        private static bool listviewSingleClick = true;
        public static bool ListviewSingleClick {
            get { return listviewSingleClick; }
            set {
                listviewSingleClick = value;
                Basis.WriteRegInt(C_REG_ADR, "setlistviewSingleClick", 1);
                Basis.WriteRegBool(C_REG_ADR, "listviewSingleClick", listviewSingleClick);
            }
        }

        public static List<String> listeMasks = new List<string>();

        public static void readlisteMasks() {
            listeMasks.Clear();
            int n = Basis.ReadRegInt(C_REG_ADR, "listeMasksCount");
            if (n==0) {
                listeMasks.Add(".flac");
                listeMasks.Add(".wav");
                listeMasks.Add(".mp3");
                writelisteMasks();
            }
            else {
                for (int i = 0; i < n; i++) {
                    String ext = Basis.ReadRegString(C_REG_ADR, "listeMasks" + i);
                    if (ext.Length > 0) {
                        listeMasks.Add(ext);
                    }
                }
            }
        }

        public static void writelisteMasks() {
           Basis.WriteRegInt(C_REG_ADR, "listeMasksCount", listeMasks.Count);
            for (int i = 0; i < listeMasks.Count; i++) {
                Basis.WriteRegString(C_REG_ADR, "listeMasks" + i, listeMasks[i]);
            }
        }




        static SingVar() {          
            
            lastPath = Basis.ReadRegString(C_REG_ADR, "lastPath");
            // || !Directory.Exists(lastPath)
            if (lastPath.Length == 0 ) {
                lastPath = System.Environment.CurrentDirectory;
            }
            else {
                if (IsDirectoryWritable(lastPath) || (lastPath.IndexOf(";") > 0)) {
                }
                else { 
                    lastPath = System.Environment.CurrentDirectory;
                }
                //System.Security.AccessControl.DirectorySecurity access = Directory.GetAccessControl(lastPath);
                // if (access.)
            }

            fontsize = Basis.ReadRegInt(C_REG_ADR, "fontsize");
            if (fontsize==0) {
                fontsize = 14;
                Basis.WriteRegInt(C_REG_ADR, "fontsize", fontsize);
            }

            int dummy = Basis.ReadRegInt(C_REG_ADR, "setlightmode");
            switch (dummy) {
                case 1:
                    colormode = AudioColors.ColorTyp.LIGHTMODE1;
                    break;
                case 2:
                    colormode = AudioColors.ColorTyp.LIGHTMODE2;
                    break;
                case 3:
                    colormode = AudioColors.ColorTyp.DARKMODE1;
                    break;
                case 4:
                    colormode = AudioColors.ColorTyp.DARKMODE2;
                    break;
                default:
                    colormode = AudioColors.ColorTyp.LIGHTMODE1;
                    break;
            }


            dummy = Basis.ReadRegInt(C_REG_ADR, "setlistviewSingleClick");
            if (dummy == 1) {
                listviewSingleClick = Basis.ReadRegBool(C_REG_ADR, "listviewSingleClick");
            }

            readlisteMasks();
            




        }  // SingVar

        private static bool IsDirectoryWritable(string dirPath) {
            try {
                using (FileStream fs = File.Create(
                    Path.Combine(
                        dirPath,
                        Path.GetRandomFileName()
                    ),
                    1,
                    FileOptions.DeleteOnClose)
                ) { }
                return true;
            }
            catch {
                return false;
            }
        }

    }
}
