﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System.Windows.Media;

//using AudioPlayer.SingVar;

namespace AudioPlayer.Tools {
    public class AudioColors {

        public enum ColorTyp {
            LIGHTMODE1 = 1,
            LIGHTMODE2 =2,
            DARKMODE1 =3,
            DARKMODE2 = 4
        }

        public SolidColorBrush brushBG = null;
        public SolidColorBrush brushMenubarBG = null;
        public SolidColorBrush brushMenubarFG = null;

        public SolidColorBrush brushToolbarBG = null;
        public SolidColorBrush brushToolbarFG = null;
        public SolidColorBrush brushToolbarTextBoxBG = null;
        public SolidColorBrush brushToolbarTextBoxFG = null;
        public SolidColorBrush brushToolbarLabelFG = null;

        
        public SolidColorBrush brushListviewBG = null;
        public SolidColorBrush brushListviewFG = null;

        public SolidColorBrush brushTreeBG = null;
        public SolidColorBrush brushTreeNodeCaptionFG = null;
        public SolidColorBrush brushTreeNode1BG = null;
        public SolidColorBrush brushTreeNode1FG = null;
        public SolidColorBrush brushTreeNode2BG = null;
        public SolidColorBrush brushTreeNode2FG = null;
        public SolidColorBrush brushTreeNode3BG = null;
        public SolidColorBrush brushTreeNode3FG = null;

        public SolidColorBrush brushTimeBG = null;
        public SolidColorBrush brushTimeFG = null;

        public SolidColorBrush brushPlayPanelBG = null;
        public SolidColorBrush brushAlbumFG = null;
        public SolidColorBrush brushArtistFG = null;
        public SolidColorBrush brushTitleFG = null;
        public SolidColorBrush brushSamplerateFG = null;


        public List<SolidColorBrush> liste = new List<SolidColorBrush>();

        public AudioColors(ColorTyp colormode) {
            
            switch (colormode) {
                case ColorTyp.LIGHTMODE1:
                    brushBG = new SolidColorBrush(Color.FromRgb(207, 224, 230));

                    brushMenubarBG = brushBG.Clone();
                    brushMenubarFG = new SolidColorBrush(Colors.Black);

                    brushToolbarBG = brushBG.Clone();
                    brushToolbarFG = new SolidColorBrush(Colors.Black);
                    brushToolbarTextBoxBG = brushBG.Clone();
                    brushToolbarTextBoxFG = new SolidColorBrush(Colors.Black);
                    brushToolbarLabelFG = new SolidColorBrush(Colors.Black);

                    brushTreeBG = new SolidColorBrush(Color.FromRgb(207, 224, 230));
                    brushTreeNodeCaptionFG = new SolidColorBrush(Colors.Red);

                    brushTreeNode1FG = new SolidColorBrush(Color.FromRgb(0x59, 0x77, 0x80));
                    brushTreeNode1BG = brushTreeBG.Clone();

                    brushTreeNode2FG = new SolidColorBrush(Color.FromRgb(0x80, 0x76, 0x59));
                    brushTreeNode2BG = new SolidColorBrush(Color.FromRgb(0xE6, 0xE0, 0xCF));

                    brushTreeNode3FG = new SolidColorBrush(Color.FromRgb(0x62, 0x5C, 0x80));
                    brushTreeNode3BG = new SolidColorBrush(Color.FromRgb(0xD4, 0xD0, 0xE6));

                    brushListviewBG = new SolidColorBrush(Color.FromRgb(207, 224, 230));
                    brushListviewFG = new SolidColorBrush(Colors.Black);

                    brushTimeBG = brushBG.Clone();
                    brushTimeFG = new SolidColorBrush(Colors.Black);

                    brushPlayPanelBG = new SolidColorBrush(Color.FromRgb(0xE6, 0xE0, 0xCF));
                    brushAlbumFG = new SolidColorBrush(Color.FromRgb(0x59, 0x77, 0x80));

                    brushArtistFG = new SolidColorBrush(Color.FromRgb(0x80, 0x6A, 0x59));
                    //brushArtistFG = new SolidColorBrush(Colors.Black);
                    brushTitleFG = new SolidColorBrush(Color.FromRgb(0x80, 0x76, 0x59));
                    brushSamplerateFG = new SolidColorBrush(Color.FromRgb(0x80, 0x76, 0x59));
                    break;

                case ColorTyp.LIGHTMODE2:
                brushBG = new SolidColorBrush(Color.FromRgb(223, 236, 244));

                brushMenubarBG = brushBG.Clone();
                //brushMenubarBG = new SolidColorBrush(Color.FromRgb(255, 0, 255)); ;
                brushMenubarFG = new SolidColorBrush(Colors.Black);

                brushToolbarBG = brushBG.Clone();
                brushToolbarFG = new SolidColorBrush(Colors.Black);
                brushToolbarTextBoxBG = brushBG.Clone();
                brushToolbarTextBoxFG = new SolidColorBrush(Colors.Black);
                brushToolbarLabelFG = new SolidColorBrush(Colors.Black);

                brushTreeBG = brushBG.Clone();
                brushTreeNodeCaptionFG = new SolidColorBrush(Colors.Red);
                brushTreeNode1FG = new SolidColorBrush(Colors.Blue);
                brushTreeNode1BG = brushTreeBG.Clone();
                brushTreeNode2FG = new SolidColorBrush(Colors.Red);
                brushTreeNode2BG = new SolidColorBrush(Color.FromRgb(255, 255, 190));
                brushTreeNode3FG = new SolidColorBrush(Colors.Green);
                brushTreeNode3BG = new SolidColorBrush(Color.FromRgb(255, 190, 190));

                brushListviewBG = brushBG.Clone();
                brushListviewFG = new SolidColorBrush(Colors.Black);

                brushTimeBG = brushBG.Clone();
                brushTimeFG = new SolidColorBrush(Colors.Black);

                brushPlayPanelBG = new SolidColorBrush(Color.FromRgb(192, 255, 190)); 
                brushAlbumFG = new SolidColorBrush(Colors.Blue);
                brushArtistFG = new SolidColorBrush(Colors.Green);
                brushTitleFG = new SolidColorBrush(Colors.Black);
                brushSamplerateFG = new SolidColorBrush(Colors.Black);
                    break;

           

            case ColorTyp.DARKMODE1:
                    // Darkmode
                    brushBG = new SolidColorBrush(Color.FromRgb(30,30,30));

                brushMenubarBG = brushBG.Clone();
                brushMenubarFG = new SolidColorBrush(Colors.LightGray);

                brushToolbarBG = brushBG.Clone();
                brushToolbarFG = new SolidColorBrush(Color.FromRgb(255, 128, 0));
                brushToolbarLabelFG = new SolidColorBrush(Colors.LightGray);
                brushToolbarTextBoxBG = brushBG.Clone();
                brushToolbarTextBoxFG = new SolidColorBrush(Color.FromRgb(255, 128, 0));

                brushTreeBG = brushBG.Clone();
                brushTreeNodeCaptionFG = new SolidColorBrush(Colors.Yellow);

                brushTreeNode1FG = new SolidColorBrush(Color.FromRgb(220, 220, 220));
                brushTreeNode1BG = new SolidColorBrush(Color.FromRgb(17, 61, 111)); 

                brushTreeNode2FG = new SolidColorBrush(Color.FromRgb(220, 220, 220));
                brushTreeNode2BG = new SolidColorBrush(Color.FromRgb(64, 111, 17));

                brushTreeNode3FG = new SolidColorBrush(Color.FromRgb(60, 197, 17));
                    brushTreeNode3BG = brushTreeBG.Clone();

                brushListviewBG = brushBG.Clone();
                brushListviewFG = new SolidColorBrush(Colors.LightGray);

                brushTimeBG = brushBG.Clone();
                brushTimeFG = new SolidColorBrush(Colors.LightGray);


                brushPlayPanelBG = new SolidColorBrush(Color.FromRgb(60, 60, 60));
                brushAlbumFG = new SolidColorBrush(Color.FromRgb(220, 220, 220));
                brushArtistFG = new SolidColorBrush(Color.FromRgb(78, 201, 176));
                brushTitleFG = new SolidColorBrush(Color.FromRgb(86, 156, 214));
                brushSamplerateFG = brushTitleFG.Clone();
                break;

                case ColorTyp.DARKMODE2:
                    // Darkmode
                    brushBG = new SolidColorBrush(Color.FromRgb(60, 60, 60));

                    brushMenubarBG = brushBG.Clone();
                    brushMenubarFG = new SolidColorBrush(Colors.LightGray);

                    brushToolbarBG = brushBG.Clone();
                    brushToolbarFG = new SolidColorBrush(Color.FromRgb(255, 128, 0));
                    brushToolbarLabelFG = new SolidColorBrush(Colors.LightGray);
                    brushToolbarTextBoxBG = brushBG.Clone();
                    brushToolbarTextBoxFG = new SolidColorBrush(Color.FromRgb(255, 128, 0));

                    brushTreeBG = brushBG.Clone();
                    brushTreeNodeCaptionFG = new SolidColorBrush(Colors.Yellow);
                    brushTreeNode1FG = new SolidColorBrush(Color.FromRgb(223, 236, 244));
                    brushTreeNode1BG = new SolidColorBrush(Color.FromRgb(60, 60, 60)); ; // brushTreeBG.Clone();

                    brushTreeNode2FG = new SolidColorBrush(Color.FromRgb(255, 255, 190));
                    brushTreeNode2BG = new SolidColorBrush(Color.FromRgb(169, 14, 21));

                    brushTreeNode3FG = new SolidColorBrush(Color.FromRgb(238, 168, 227));
                    brushTreeNode3BG = new SolidColorBrush(Color.FromRgb(46, 115, 26));

                    brushListviewBG = brushBG.Clone();
                    brushListviewFG = new SolidColorBrush(Colors.LightGray);

                    brushTimeBG = brushBG.Clone();
                    brushTimeFG = new SolidColorBrush(Colors.LightGray);

                    brushPlayPanelBG = new SolidColorBrush(Color.FromRgb(28, 33, 102));
                    brushAlbumFG = new SolidColorBrush(Color.FromRgb(255, 192, 130));
                    brushArtistFG = new SolidColorBrush(Color.FromRgb(192, 255, 130));
                    brushTitleFG = new SolidColorBrush(Color.FromRgb(255, 192, 130));
                    brushSamplerateFG = new SolidColorBrush(Color.FromRgb(255, 255, 187));
                    break;

            }

            liste.Add(brushBG);
            liste.Add(brushMenubarBG);
            liste.Add(brushMenubarFG);

            liste.Add(brushToolbarBG);
            liste.Add(brushToolbarFG);
            liste.Add(brushToolbarTextBoxBG);
            liste.Add(brushToolbarTextBoxFG);
            liste.Add(brushToolbarLabelFG);
                        
            liste.Add(brushListviewBG);
            liste.Add(brushListviewFG);

            liste.Add(brushTreeBG);
            liste.Add(brushTreeNodeCaptionFG);
            liste.Add(brushTreeNode1BG);
            liste.Add(brushTreeNode1FG);
            liste.Add(brushTreeNode2BG);
            liste.Add(brushTreeNode2FG);
            liste.Add(brushTreeNode3BG);
            liste.Add(brushTreeNode3FG);

            liste.Add(brushTimeBG);
            liste.Add(brushTimeFG);

            liste.Add(brushPlayPanelBG);
            liste.Add(brushAlbumFG);
            liste.Add(brushArtistFG);
            liste.Add(brushTitleFG);
            liste.Add(brushSamplerateFG);
            
    }  // Konstruktor


       
        public void loadFromRegistry() {
            SolidColorBrush brush = null;
            int registryVorhanden = Basis.ReadRegInt(SingVar.C_REG_ADR_COLORS, "colors");
            if (registryVorhanden == 1) {
                for (int i = 0; i < liste.Count; i++) {
                    brush = liste[i];
                    byte red = (byte)Basis.ReadRegInt(SingVar.C_REG_ADR_COLORS, "color-" + i + "-red");
                    byte green = (byte)Basis.ReadRegInt(SingVar.C_REG_ADR_COLORS, "color-" + i + "-green");
                    byte blue = (byte)Basis.ReadRegInt(SingVar.C_REG_ADR_COLORS, "color-" + i + "-blue");
                    brush.Color = Color.FromRgb(red, green, blue);
                }
            }
        }  // loadFromRegistry

        public void save2Registry() {
            SolidColorBrush brush=null;
            Basis.WriteRegInt(SingVar.C_REG_ADR_COLORS, "colors", 1);
            for (int i=0; i<liste.Count; i++) {
                brush = liste[i];
                Basis.WriteRegInt(SingVar.C_REG_ADR_COLORS, "color-" + i + "-red", brush.Color.R);
                Basis.WriteRegInt(SingVar.C_REG_ADR_COLORS, "color-" + i + "-green", brush.Color.G);
                Basis.WriteRegInt(SingVar.C_REG_ADR_COLORS, "color-" + i + "-blue", brush.Color.B);
            }
        }  // save2Registry


        // MenubarBackground;60;60;60
        public bool loadColor(String line, SolidColorBrush brush) {
            bool okay = true;
            string[] splitStrings = { ";" };
            string[] lines = line.Split(splitStrings, StringSplitOptions.None);
            if (lines.Length == 4) {
                byte red, green, blue;
                if (byte.TryParse(lines[1], out red) && byte.TryParse(lines[2], out green) && byte.TryParse(lines[3], out blue)) {
                    brush.Color = Color.FromRgb(red, green, blue);
                }
                else {
                    okay = false;
                }
            }
            return okay;
        }

        public void loadfile(String fileName) {
            String[] lines = File.ReadAllLines(fileName);
            String version = lines[1];
            String formatline = lines[2];
            if (version=="1") {
                int row = 2;
                foreach(SolidColorBrush brush in liste) {
                    row++;
                    if (!loadColor(lines[row], brush)) {
                        Basis.ErrorMsg("Error reading the data from the color file\r\nLineno: "+row,"Error");
                        return;
                    }
                }
            }
        }  // loadfile

        
        public void saveColor(StringBuilder sb, String caption, SolidColorBrush brush) {
            sb.Append(caption);
            sb.Append(";");
            sb.Append(brush.Color.R.ToString());
            sb.Append(";");
            sb.Append(brush.Color.G.ToString());
            sb.Append(";");
            sb.AppendLine(brush.Color.B.ToString());
        }

        public void savefile(String fileName) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Dummyline for the colors of the audioplayer");
            sb.AppendLine("1");  // Version
            sb.AppendLine("Format: caption;red;green;blue");
                        
            saveColor(sb, "Background", brushBG);
                        
            saveColor(sb, "MenubarBackground", brushMenubarBG);                       
            saveColor(sb, "MenubarForeground", brushMenubarFG);
                        
            saveColor(sb, "ToolbarBackground", brushToolbarBG);
            saveColor(sb, "ToolbarForeground", brushToolbarFG);                        
            saveColor(sb, "ToolbarLabelForeground", brushToolbarLabelFG);            
            saveColor(sb, "ToolbarTextBoxBackground", brushToolbarTextBoxBG);
            saveColor(sb, "ToolbarTextBoxForeground", brushToolbarTextBoxFG);
            

            saveColor(sb, "TreeBackground", brushTreeBG);            
            saveColor(sb, "TreeCaptionForeground", brushTreeNodeCaptionFG);

            saveColor(sb, "TreeNode1Background", brushTreeNode1BG);
            saveColor(sb, "TreeNode1Foreground", brushTreeNode1FG);

            saveColor(sb, "TreeNode2Background", brushTreeNode2BG);
            saveColor(sb, "TreeNode2Foreground", brushTreeNode2FG);

            saveColor(sb, "TreeNode3Background", brushTreeNode3BG);
            saveColor(sb, "TreeNode3Foreground", brushTreeNode3FG);


            saveColor(sb, "ListViewBackground", brushListviewBG);
            saveColor(sb, "ListViewForeground", brushListviewFG);


            saveColor(sb, "TimeBackground", brushTimeBG);
            saveColor(sb, "TimeForeground", brushTimeFG);


            saveColor(sb, "PlayerPanelground", brushPlayPanelBG);
            saveColor(sb, "AlbumForeground", brushAlbumFG);
            saveColor(sb, "ArtistForeground", brushArtistFG);
            saveColor(sb, "TitleForeground", brushTitleFG);
            saveColor(sb, "SamplerateForeground", brushSamplerateFG);

            File.WriteAllText(fileName, sb.ToString());
        }
    }
}
