﻿using System;
using System.Collections.Generic;

using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.IO;

namespace AudioPlayer.Tools {
    public class FileItem : IComparable {
        private String fullname = "";
        private String filename = "";
        private String ext = "";
        private long size = 0;


        public FileItem(FileInfo fileinfo) {
            fullname = fileinfo.FullName;
            filename = fileinfo.Name;

            ext = Basis.getFilenameExt(fileinfo.Name);
            size = fileinfo.Length;
        }

        public String Ext {
            get {
                if (ext.Length == 0)
                    return "";
                else
                    return ext.Substring(1).ToUpper();
            }
            set { ext = value; }
        }
        public String Fullname {
            get { return fullname; }
            set { fullname = value; }
        }
        public String Filename {
            get { return filename; }
            set { filename = value; }
        }

        public String StringSize {
            get {
                if (size == 0)
                    return "";
                else
                    return "    "+Basis.Best_KB(size);
            }
        }
        public long Size {
            get { return size; }
            set { size = value; }
        }

        public int CompareTo(object obj) {
            FileItem fileitem = (FileItem)obj;
            int erg = this.Filename.CompareTo(fileitem.Filename);
            return erg;
        }



    }
}
