﻿using System;
using System.Collections.Generic;

using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.IO;
using System.Runtime.Serialization.Formatters.Binary;

// file:///D:/progs/wpf/Projekte/AudioPlayer/AudioPlayer/bin/Debug/flac-1.3.2-win/html/format.html#metadata_block_streaminfo


namespace AudioPlayer.Tools {
    public class Flac {
        public String filename = "";
        public String album = "";
        public String artist = "";
        public String title = "";
        

        public int samplerate = 0;
        public int minutes = 0;
        public int seconds = 0;
        public int bitcount = 0;

        public Flac(String filename) {
            this.filename = filename;
        }

        public bool readSamplerate() {
            FileStream fin = new FileStream(this.filename, FileMode.Open, FileAccess.Read);
            BinaryReader bin = new BinaryReader(fin);
            // fLaC
            
            byte[] headerSoll = { 0x66, 0x4C, 0x61, 0x43 };
            byte[] header = new byte[headerSoll.Length];
            header = bin.ReadBytes(header.Length);
            for (int i = 0; i < headerSoll.Length; i++) {
                if (headerSoll[i] != header[i]) {
                    Basis.ErrorMsg("Error, the audiofile is not a FLAC-File\r\n" + filename, "Error");
                    bin.Close();
                    fin.Close();
                    return false;
                }
            }

            // samplerate
            fin.Seek(0x12,SeekOrigin.Begin);  // jump to the first byte of the sampleRate
            
            byte[] samplerates = new byte[3];
            //dummy1 = bin.ReadBytes(dummy1.Length);
            samplerates = bin.ReadBytes(samplerates.Length);  // adr: 12=byte[0], 13=byte[1], 14=byte[2]   Bits:  12+13+ highbyte(14)
            int b0 = samplerates[0];
            int b1 = samplerates[1];
            int b2 = samplerates[2];
            samplerate = (b0 << 12) | (b1 << 4) | (b2 >> 4);  // 192 kHz

            //fin.Seek(0x12, SeekOrigin.Begin);  // jump to the first byte of the sampleRate

            byte[] samplescount = new byte[5];
            samplescount = bin.ReadBytes(samplescount.Length);  // 0x15  bis 0x19  von 0x15 nur die unteren bits
            int sc0 = samplescount[0] & 0xF;
            int sc1 = samplescount[1];
            int sc2 = samplescount[2];
            int sc3 = samplescount[3];
            int sc4 = samplescount[4];
            long scount = (sc0 << 32) | (sc1 << 24) | (sc2 << 16) | (sc3 << 8) | sc4;
            long seconds = (long) (scount / samplerate);
            this.minutes = (int)(seconds / 60.0);
            this.seconds = (int)(seconds % 60);


            byte[] channels = new byte[3];
            channels = bin.ReadBytes(channels.Length);  // 0x15  bis 0x19  von 0x15 nur die unteren bits

            int bitcount0 = samplescount[0] >> 4;  // F
            int bitcount1 = samplerates[2] & 0xF;  // 2
            bitcount = (bitcount1<<4) | bitcount0;
            // es sind nur 5 Bit zuständig
            bitcount = bitcount >> 3;

            /*   https://xiph.org/flac/format.html#def_STREAMINFO
            000 : get from STREAMINFO metadata block
    001 : 8 bits per sample
    010 : 12 bits per sample
    011 : reserved
    100 : 16 bits per sample
    101 : 20 bits per sample
    110 : 24 bits per sample
    111 : reserved
    */

            if (bitcount==5) {
                bitcount = 16;
            }
            else if (bitcount == 6) {
                bitcount = 24;
            }
            else {
                Basis.ErrorMsg("Error to get the bits/sample\r\nPlease send an email to mwilhelm@hs-harz.de", "Error");
                bitcount = -1;
            }

                bin.Close();
            fin.Close();           
            return true;
        }
        /*

    000 : get from STREAMINFO metadata block
    001 : 8 bits per sample
    010 : 12 bits per sample
    011 : reserved
    100 : 16 bits per sample
    101 : 20 bits per sample
    110 : 24 bits per sample
    111 : reserved

 *          */

        public bool readTexte() {
            FileStream fin = new FileStream(this.filename, FileMode.Open, FileAccess.Read);
            BinaryReader bin = new BinaryReader(fin);
            // fLaC
            
            byte[] headerSoll = { 0x66, 0x4C, 0x61, 0x43 };
            byte[] header = new byte[headerSoll.Length];
            header = bin.ReadBytes(header.Length);
            for (int i1 = 0; i1 < headerSoll.Length; i1++) {
                if (headerSoll[i1] != header[i1]) {
                    Basis.ErrorMsg("Error, the audiofile is not a FLAC-File\r\n" + filename, "Error");
                    bin.Close();
                    fin.Close();
                    return false;
                }
            }


            fin.Seek(0, SeekOrigin.Begin);
            byte[] bytes = new byte[10000];
            bytes = bin.ReadBytes(bytes.Length);
            // suche reference, dann ALBUMARTIST, ALBUM    TITLE title
           
            String searchItem = "reference";
            bool reference = false;
            int i = 0;
            byte b = 0;
            int positionReference = searchString(bytes, searchItem);
            if (positionReference == -1) {
                int p1 = searchString(bytes, "ALBUM=");
                int p2 = searchString(bytes, "TITLE=");
                int p3 = searchString(bytes, "title=");
                int p4 = searchString(bytes, "ARTIST=");
                if (p1 > 0 && p4 > 0 && (p2 > 0 || p3 > 0)) {
                    // nun gibt es doch einträge
                    bin.Close();
                    fin.Close();
                    // nun weiter siehe unten
                }
                else {
                    Basis.ErrorMsg("Error, the audiofile has not a reference-Block\r\n" + filename, "Error");
                    bin.Close();
                    fin.Close();
                    return false;
                }
            }
            else {
                positionReference += searchItem.Length;  // Position auf das Byte nach der reference setzen
                fin.Seek(positionReference, SeekOrigin.Begin);
                bytes = bin.ReadBytes(bytes.Length);  // nun nach reference lesen
                bin.Close();
                fin.Close();
            }

            album = "Please send an email to me!";
            artist = "Please send an email to me!";
            title = "Please send an email to me!";
            searchItem = "ALBUM=";
            int position = searchString(bytes, searchItem);
            if (position == -1) {
                searchItem = "Album=";
                position = searchString(bytes, searchItem);
                if (position == -1) {
                    searchItem = "album=";
                    position = searchString(bytes, searchItem);
                    if (position == -1) {
                        Basis.ErrorMsg("Error, the audiofile has no ALBUM-Text\r\n" + filename, "Error");
                        return false;
                    }
                }
            }
            position += searchItem.Length;
            album = searchTextUntilZero(bytes, position);

            // -----------------------------------------
            searchItem = "TITLE=";
            position = searchString(bytes, searchItem);
            if (position==-1) {
                searchItem = "Title=";
                position = searchString(bytes, searchItem);
                if ((position == -1) ) {
                    searchItem = "title=";
                    position = searchString(bytes, searchItem);
                    if ((position == -1)) {
                        Basis.ErrorMsg("Error, the audiofile has no TITLE-Text\r\n" + filename, "Error");
                        return false;
                    }
                }
            }
            if (position > 0) {
                title = searchTextUntilZero(bytes, position);
            }


            searchItem = "ARTIST=";
            position = searchString(bytes, searchItem);
            if (position == -1) {
                searchItem = "Artist=";
                position = searchString(bytes, searchItem);
                if ((position == -1)) {
                    searchItem = "artist=";
                    position = searchString(bytes, searchItem);
                    if ((position == -1)) {
                        Basis.ErrorMsg("Error, the audiofile has no Artist-Text\r\n" + filename, "Error");
                        return false;
                    }
                }
            }
            if (position > 0) {
                artist = searchTextUntilZero(bytes, position);
            }


            return true;
        }  // readTexte

        private String searchTextUntilZero(byte[] bytes, int position) {
            StringBuilder sb = new StringBuilder();
            for (int i=position; i<bytes.Length; i++) {
                if (bytes[i]==0) {
                    break;
                }
                else {
                    if (bytes[i]>=32) {
                        if (bytes[i] == 0xC3  && bytes[i+1] == 0xBC) {
                            sb.Append("ü");
                            i++;
                        }
                        else {
                            sb.Append((char)bytes[i]);
                        }                            
                    }
                }
            }
            return sb.ToString();
        }  // searchTextUntilZero

        private int searchString(byte[] bytes, String searchItem) {
            int position = -1;
            byte[] searchItemBytes = new byte[searchItem.Length]; // Unicode !!
            for (int i = 0; i < searchItem.Length; i++) {
                searchItemBytes[i] = (byte)searchItem[i];
            }
            for(int i =0; i< bytes.Length;i++) {
                if (bytes[i] == searchItemBytes[0]) {
                    // prüfe die Länge
                    bool okay = true;
                    for (int j = 0; j < searchItem.Length; j++) {
                        if (i + j < bytes.Length) {
                            if (bytes[i + j] != searchItemBytes[j]) {  // error bei Paul Simon #14
                                okay = false;
                                break;
                            }
                        }
                        else {
                            break;
                        }
                    }
                    if (okay) {
                        position = i;
                    }
                }
            }

            return position;
        }



    }
}

/*
https://stackoverflow.com/questions/6196136/readdata-for-24-bit-flac-and-wav-files


FMOD.RESULT result = FMOD.RESULT.OK;
            FileStream fileStream = null;
            BinaryWriter binaryWriter = null;
            GZipStream gzipStream = null;
            bool generatePeakFile = false;
            int CHUNKSIZE = 0;
            uint length = 0;
            uint read = 0;
            uint bytesread = 0;
            Int16[] left16BitArray = null;
            Int16[] right16BitArray = null;
            Int32[] left32BitArray = null;
            Int32[] right32BitArray = null;
            float[] floatLeft = null;
            float[] floatRight = null;
            byte[] buffer = null;
            IntPtr data = new IntPtr(); // initialized properly later
            WaveDataMinMax minMax = null;

            try
            {
                // Set current file directory
                m_peakFileDirectory = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location) + "\\Peak Files\\";

                // Get file name from argument
                string fileName = (string)e.Argument;

                // Create sound system with NOSOUND
                MPfm.Sound.System soundSystem = new MPfm.Sound.System(FMOD.OUTPUTTYPE.NOSOUND, string.Empty);

                // Create sound
                MPfm.Sound.Sound sound = soundSystem.CreateSound(fileName, false);

                // Get sound format; specifically bits per sample (changes the calculations later)
                SoundFormat soundFormat = sound.GetSoundFormat();

                // Get the length of the file in PCM bytes               
                sound.BaseSound.getLength(ref length, FMOD.TIMEUNIT.PCMBYTES);

                // Check if the folder for peak files exists
                if (!Directory.Exists(PeakFileDirectory))
                {
                    // Create directory
                    Directory.CreateDirectory(PeakFileDirectory);
                }

                // Generate the file name for the peak file by using the full path without special characters
                string peakFilePath = PeakFileDirectory + fileName.Replace(@"\", "_").Replace(":", "_").Replace(".", "_") + ".mpfmPeak";

                // Check if peak file exists                
                if(!File.Exists(peakFilePath))
                {
                    // Set flag
                    generatePeakFile = true;

                    // Create peak file
                    fileStream = new FileStream(peakFilePath, FileMode.Create, FileAccess.Write);
                    binaryWriter = new BinaryWriter(fileStream);
                    gzipStream = new GZipStream(fileStream, CompressionMode.Compress);                   
                }

                // Check the bits per sample to determine what chunk size to get                
                if (soundFormat.BitsPerSample == 16)
                {
                    // 4096 bytes for 16-bit PCM data
                    CHUNKSIZE = 4096;
                }
                else if (soundFormat.BitsPerSample == 24)
                {
                    // 699050.625 bytes for 24-bit PCM data (???)   
                    CHUNKSIZE = 699051;
                }

                // Create buffer
                data = Marshal.AllocHGlobal(CHUNKSIZE);
                buffer = new byte[CHUNKSIZE];

                // Loop through file using chunk size
                do
                {
                    // Check for cancel
                    if (m_workerWaveForm.CancellationPending)
                    {
                        return;
                    }

                    // Check the bits per sample
                    if (soundFormat.BitsPerSample == 16)
                    {
                        // Read data chunk (4096 bytes for 16-bit PCM data)
                        result = sound.BaseSound.readData(data, (uint)CHUNKSIZE, ref read);
                        Marshal.Copy(data, buffer, 0, CHUNKSIZE);
                        bytesread += read;

                        // Is freehglobal needed? it crashes after one use.
                        //Marshal.FreeHGlobal(data);

                        // Convert the byte (8-bit) arrays into a short (16-bit) arrays (signed values)
                        left16BitArray = new Int16[buffer.Length / 4];
                        right16BitArray = new Int16[buffer.Length / 4];

                        // Loop through byte (8-bit) array buffer; increment by 4 (i.e. 4 times more data in 16-bit than 8-bit)
                        for (int i = 0; i < buffer.Length; i = i + 4)
                        {
                            // Convert values to 16-bit
                            left16BitArray[i / 4] = BitConverter.ToInt16(buffer, i);
                            right16BitArray[i / 4] = BitConverter.ToInt16(buffer, i + 2); // alternate between left and right channel
                        }

                        // Convert the short arrays to float arrays (signed values)
                        // This will convert the -32768 to 32768 value range to -1 to 1 (useful for wave display) 
                        floatLeft = new float[left16BitArray.Length];
                        floatRight = new float[left16BitArray.Length];
                        for (int i = 0; i < left16BitArray.Length; i++)
                        {
                            // 16-bit data for unsigned values range from 0 to 65536.
                            floatLeft[i] = left16BitArray[i] / 65536.0f;
                            floatRight[i] = right16BitArray[i] / 65536.0f;                            
                        }
                    }
                    else if (soundFormat.BitsPerSample == 24)
                    {
                       // (non-working code removed)

                        // (I have no idea if this works) Convert the short arrays to float arrays (signed values)
                        // This will convert the -8388608 to 8388608value range to -1 to 1 (useful for wave display) 
                        floatLeft = new float[left32BitArray.Length];
                        floatRight = new float[left32BitArray.Length];
                        for (int i = 0; i < left32BitArray.Length; i++)
                        {
                            // 16-bit data for unsigned values range from 0 to 16777215.
                            floatLeft[i] = left32BitArray[i] / 16777215.0f;
                            floatRight[i] = right32BitArray[i] / 16777215.0f;                            
                        }
                    }

                    // Calculate min/max
                    minMax = AudioTools.GetMinMaxFromWaveData(floatLeft, floatRight, false);
                    WaveDataHistory.Add(minMax);

                    // Report progress
                    m_bytesRead = bytesread;
                    m_totalBytes = length;
                    m_percentageDone = ((float)bytesread / (float)length) * 100;

                    // Write peak information to hard disk
                    if (generatePeakFile)
                    {
                        // Write peak information
                        binaryWriter.Write((double)minMax.leftMin);
                        binaryWriter.Write((double)minMax.leftMax);
                        binaryWriter.Write((double)minMax.rightMin);
                        binaryWriter.Write((double)minMax.rightMax);
                        binaryWriter.Write((double)minMax.mixMin);
                        binaryWriter.Write((double)minMax.mixMax);
                    }                  
                }
                while (result == FMOD.RESULT.OK && read == CHUNKSIZE);

                // Release sound from memory
                sound.Release();

                // Close sound system and release from memory
                soundSystem.Close();
                soundSystem.Release();

                // Set nulls for garbage collection               
                sound = null;
                soundSystem = null;
                left16BitArray = null;
                right16BitArray = null;
                left32BitArray = null;
                right32BitArray = null;
                floatLeft = null;
                floatRight = null;                
                buffer = null;
                minMax = null;
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                // Did we have to generate a peak file?
                if (generatePeakFile)
                {
                    // Close writer and stream
                    gzipStream.Close();
                    binaryWriter.Close();                   
                    fileStream.Close();

                    // Set nulls
                    gzipStream = null;
                    binaryWriter = null;
                    fileStream = null;
                }
            }

            // Call garbage collector
            GC.Collect();




    */
