﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace AudioPlayer.Tools {
    /// <summary>
    /// Interaction logic for WCreateSearchLIst.xaml
    /// </summary>
    public partial class WCreateSearchLIst : Window {

        public List<FileItem> playList = new List<FileItem>();


        private bool retcode = false;
        public bool Retcode {
            get { return retcode; }
        }


        private String audiopaths;
        private List<FileItem> allFileList = new List<FileItem>();


        public WCreateSearchLIst(Window owner, String audiopaths) {
            InitializeComponent();
            this.Owner = owner;
            this.audiopaths = audiopaths.Trim();
            // this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }


        private void Window_Loaded(object sender, RoutedEventArgs e) {
            if (audiopaths.Length == 0) {
                Basis.Message("There are no items in the audiofile-tree", "Info");
                Close();
            }
            String[] lines = null;
            if (audiopaths.IndexOf(";") > 0) {
                string[] splitStrings = { ";" };
                lines = audiopaths.Split(splitStrings, StringSplitOptions.None);
            }
            else {
                lines = new String[1];
                lines[0] = audiopaths;
            }

            allFileList.Clear();
            foreach (String path in lines) {
                if (Directory.Exists(path)) {
                    DirectoryInfo mainDir = new DirectoryInfo(path);
                    foreach (String audiofiletyp in SingVar.listeMasks) {
                        FileInfo[] files = mainDir.GetFiles("*" + audiofiletyp, SearchOption.AllDirectories);
                        foreach (FileInfo fileinfo in files) {
                            FileItem fileitem = new FileItem(fileinfo);
                            allFileList.Add(fileitem);
                        }
                    }                        
                }
            }

            
            tSearchItem.Focus();
            setFontsize();
            // Basis.setWindowPositionFromRegistry(this, IGMRegistry.C_REG_ADR_IGM + "\\position", "table" + dbtable);
        }

        private void setFontsize() {
            this.FontSize = SingVar.Fontsize;
            labelTitel.FontSize =SingVar.Fontsize+1;
        }

        private void bnSearch_Click(Object sender, RoutedEventArgs e) {
            listBox.Items.Clear();

            String searchtext = tSearchItem.Text.Trim();
            if (searchtext.Length==0) {
                tSearchItem.Focus();
                Basis.Message("Please enter a text in the input-filed", "Info");
                return;
            }
            String[] searchLines = null;
            if (searchtext.IndexOf(";") > 0) {
                string[] splitStrings = { ";" };
                searchLines = searchtext.Split(splitStrings, StringSplitOptions.None);
            }
            else {
                searchLines = new String[1];
                searchLines[0] = searchtext;
            }
            Hashtable audiofilesht = new Hashtable();
            // doppelte entfernen !

            if (rbSearchFilesOnly.IsChecked==true) {
                foreach (FileItem fileitem in allFileList) {
                    String item = fileitem.Filename.ToLower();
                    foreach (String searchText in searchLines) {
                        if (item.IndexOf(searchText.ToLower()) >= 0) {
                            if (!audiofilesht.ContainsKey(fileitem.Fullname)) {
                                audiofilesht.Add(fileitem.Fullname, fileitem);
                            }
                            break;
                        }
                    }
                } // foreach (FileItem fileitem in allFileList ) {
            }
            else {                
                String[] lines = null;
                if (audiopaths.IndexOf(";") > 0) {
                    string[] splitStrings = { ";" };
                    lines = audiopaths.Split(splitStrings, StringSplitOptions.None);
                }
                else {
                    lines = new String[1];
                    lines[0] = audiopaths;
                }

                foreach (String path in lines) {
                    if (!Directory.Exists(path)) {
                        // Basis.Message("The path to the audio-files are not exists\r\nPath: " + path, "Error");
                        continue;
                    }
                    checkDirectories(audiofilesht, searchLines, path, rbSearchFilesAndFolders.IsChecked==true);
                }
            }


            List<FileItem> audioliste = new List<FileItem>();
            foreach (FileItem fileitem in audiofilesht.Values) {
                audioliste.Add(fileitem);               
            }

            audioliste.Sort();

            foreach (FileItem fileitem in audioliste) {
                addItem(fileitem);
            }
        }  // bnSearch_Click

        private void checkDirectory(Hashtable audiofilesht, String[] searchLines, String directory) {
            foreach (String searchText in searchLines) {
                if (directory.ToLower().IndexOf(searchText.ToLower()) >= 0) {
                    DirectoryInfo mainDir = new DirectoryInfo(directory);
                    foreach (String audiofiletyp in SingVar.listeMasks) {
                        FileInfo[] files = mainDir.GetFiles("*" + audiofiletyp, SearchOption.TopDirectoryOnly);
                        foreach (FileInfo fileinfo in files) {
                            FileItem fileitem = new FileItem(fileinfo);
                            if (!audiofilesht.ContainsKey(fileitem.Fullname)) {
                                audiofilesht.Add(fileitem.Fullname, fileitem);
                            }
                        }
                    }
                    break;
                }
            }
        }  // checkDirectory

        private void checkFilesInDirectory(Hashtable audiofilesht, String[] searchLines, String directory) {
            DirectoryInfo mainDir = new DirectoryInfo(directory);
            foreach (String audiofiletyp in SingVar.listeMasks) {
                FileInfo[] files = mainDir.GetFiles("*" + audiofiletyp, SearchOption.TopDirectoryOnly);
                foreach (FileInfo fileinfo in files) {
                    foreach (String searchText in searchLines) {
                        if (fileinfo.Name.ToLower().IndexOf(searchText.ToLower()) >= 0) {
                            FileItem fileitem = new FileItem(fileinfo);
                            if (!audiofilesht.ContainsKey(fileitem.Fullname)) {
                                audiofilesht.Add(fileitem.Fullname, fileitem);
                            }
                        }
                    }
                }
            }
        }  // checkDirectory

        private void checkDirectories(Hashtable audiofilesht, String[] searchLines,  String directory, bool withFiles) {
            checkDirectory(audiofilesht, searchLines, directory);
            if (!directory.EndsWith("\\")) {
                directory += "\\";
            }
            if (withFiles) {
                checkFilesInDirectory(audiofilesht, searchLines, directory);
            }

            // Rekursion aufrufen
            String[] directories = Directory.GetDirectories(directory, "*.*", SearchOption.TopDirectoryOnly);
            foreach (String directoryname in directories) {
                FileInfo fi = new FileInfo(directoryname);
                checkDirectories(audiofilesht, searchLines, fi.FullName, withFiles);
            }

        }  // bnStartSearchFiles_Click


        private void addItem(FileItem fileitem) {
            ListBoxItem li = new ListBoxItem();
            CheckBox chk = new CheckBox();
            chk.Tag = fileitem;
            chk.IsChecked = true;
            chk.ToolTip = fileitem.Fullname;
            // unterstrich gilt als HotKey à la &
            chk.Content = fileitem.Filename.Replace("_", "__");
            //chk.Content = fileitem.Fullname;

            li.Content = chk;
            listBox.Items.Add(li);
        }


        private void MnSelectAll_Click(object sender, RoutedEventArgs e) {
            ListBoxItem li;
            CheckBox chk;
            for (int i = 0; i < listBox.Items.Count; i++) {
                li = (ListBoxItem)listBox.Items[i];
                chk = (CheckBox)li.Content;
                chk.IsChecked = true;
            }
        }

        private void MnDeselectAll_Click(object sender, RoutedEventArgs e) {
            ListBoxItem li;
            CheckBox chk;
            for (int i = 0; i < listBox.Items.Count; i++) {
                li = (ListBoxItem)listBox.Items[i];
                chk = (CheckBox)li.Content;
                chk.IsChecked = false;
            }
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                bnSearch_Click(sender, e);
                //bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Cancel)) {
                e.Handled = true;
                bnEsc_Click(sender, e);
            }
        }



        private void bnPlay_Click(Object sender, RoutedEventArgs e) {
            ListBoxItem li;
            CheckBox chkbox;
            FileItem fileitem;
            playList.Clear();
            for (int i = 0; i < listBox.Items.Count; i++) {
                li = (ListBoxItem)listBox.Items[i];
                chkbox = (CheckBox)li.Content;
                if (chkbox.IsChecked == true) {
                    fileitem = (FileItem)chkbox.Tag;
                    playList.Add(fileitem);
                }
            }
            retcode = true;
            Close();
        }





        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

    }
}
