﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace AudioPlayer.Tools {
    /// <summary>
    /// Interaction logic for WInsertDirectory.xaml
    /// </summary>
    public partial class WInsertDirectory : Window {

        private String dbtable = "InsertDirectory";

        private bool retcode = false;

        public bool Retcode {
            get { return retcode; }
        }

        public String NewDirectory {
            get { return tInput.Text.Trim(); }
        }

        public WInsertDirectory(Window parent) {
            InitializeComponent();
            Basis.setWindowPositionFromRegistry(this, SingVar.C_REG_ADR + "\\position", "dialog" + dbtable);
            this.Owner = parent;  // Important, because CenterOwner      
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tInput.Focus();
            setFontsize();
        }
        private void setFontsize() {
            int fHeadersize = SingVar.Fontsize+1;
            int fNormalsize = SingVar.Fontsize;
            this.FontSize = fNormalsize;
            labelTitel.FontSize = fHeadersize;
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            String newFile = tInput.Text.Trim();
            if (Basis.CheckFilename(newFile)) {
                retcode = true;
                Close();
            }
            else {
                Basis.ErrorMsg("The name of the folder are not correct", "Hinweis");
            }
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                bnEsc_Click(sender, e);
            }
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, SingVar.C_REG_ADR + "\\position", "dialog" + dbtable);
        }
    }
}
