﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using Microsoft.Win32;

namespace AudioPlayer.Tools {
    /// <summary>
    /// Interaction logic for WOptions.xaml
    /// </summary>
    public partial class WOptions : Window {

       // private String dialogname = "WOptions";

        private Boolean result = false;

        public Boolean Result {
            get { return result; }
        }


        private AudioColors audioColorsOri = null;
        private AudioColors audioColors = new AudioColors(AudioColors.ColorTyp.LIGHTMODE1);

        private bool start = true;

        private List<TextBox> listeColorPanel = new List<TextBox>();

        private List<String> listeMasks = new List<String>();

        public WOptions(Window parent, AudioColors audioColors) {
            // WindowStartupLocation="CenterOwner"
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner
            //this.WindowStartupLocation = WindowStartupLocation.CenterOwner; // nur in XAML
            audioColors.save2Registry();
            this.audioColors.loadFromRegistry();

            // this.audioColors.loadfile(Basis.getProgPath() + "dummy.colors");

        }


        private void Window_Loaded(object sender, RoutedEventArgs e) {

            tabControl.SelectedIndex = 0;


            if (SingVar.ListviewSingleClick) {
                rbSingleClickListView.IsChecked = true;
            }
            else {
                rbDoubleClickListView.IsChecked = true;
            }

            foreach(String mask in SingVar.listeMasks) {
                this.listeMasks.Add(mask);
            }

           
            listviewMasks.ItemsSource = null; ;
            listviewMasks.ItemsSource = this.listeMasks;


            start = false;
            cbTabs_SelectionChanged(null, null);


            listeColorPanel.Add(tbrushBG);
            listeColorPanel.Add(tbrushMenubarBG);
            listeColorPanel.Add(tbrushMenubarFG);
            listeColorPanel.Add(tbrushToolbarBG);
            listeColorPanel.Add(tbrushToolbarFG);
            listeColorPanel.Add(tbrushToolbarTextBoxBG);
            listeColorPanel.Add(tbrushToolbarTextBoxFG);
            listeColorPanel.Add(tbrushToolbarLabelFG);
            listeColorPanel.Add(tbrushListviewBG);
            listeColorPanel.Add(tbrushListviewFG);
            listeColorPanel.Add(tbrushTreeBG);
            listeColorPanel.Add(tbrushTreeNodeCaptionFG);
            listeColorPanel.Add(tbrushTreeNode1FG);
            listeColorPanel.Add(tbrushTreeNode1BG);
            listeColorPanel.Add(tbrushTreeNode2FG);
            listeColorPanel.Add(tbrushTreeNode2BG);
            listeColorPanel.Add(tbrushTreeNode3FG);
            listeColorPanel.Add(tbrushTreeNode3BG);
            listeColorPanel.Add(tbrushTimeBG);
            listeColorPanel.Add(tbrushTimeFG);
            listeColorPanel.Add(tbrushPlayPanelBG);
            listeColorPanel.Add(tbrushAlbumFG);
            listeColorPanel.Add(tbrushArtistFG);
            listeColorPanel.Add(tbrushTitleFG);
            listeColorPanel.Add(tbrushSamplerateFG);

            setColors();

           // Basis.setWindowPositionFromRegistry(this, SingVar.C_REG_ADR + "\\position", "table" + dialogname);


        }  // Window_Loaded

        private void cbTabs_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
            if (start) return;
        }



        private void setColors() {
            SolidColorBrush brush;
            TextBox textbox;
            for (int i=0; i<this.audioColors.liste.Count; i++) {            
                brush = this.audioColors.liste[i];
                textbox = this.listeColorPanel[i];
                textbox.Background = brush;
            }
        }
     


        private void bnbrush_Click(Object sender, RoutedEventArgs e) {
            Button bn = (Button)e.Source;
            if (bn!=null) {
                String s = (String)bn.Tag;
                int index;
                if (int.TryParse(s, out index)) {
                    SolidColorBrush brush = this.audioColors.liste[index];
                    TextBox textbox = this.listeColorPanel[index];
                    WColorDialog dialog = new WColorDialog();
                    dialog.setColor(brush.Color.R, brush.Color.G, brush.Color.B);
                    dialog.ShowDialog();
                    if (dialog.Retcode) {
                        brush.Color = Color.FromRgb(dialog.Red, dialog.Green, dialog.Blue);
                        textbox.Background = brush;    
                    }
                }
            }
        }


        private void listviewMasks_PreviewMouseDoubleClick(Object sender, MouseButtonEventArgs e) {
            int row = listviewMasks.SelectedIndex;
            bnEditMasks_Click(row);
        }
        private void bnEditMasks_Click(Object sender, RoutedEventArgs e) {
            int row = listviewMasks.SelectedIndex;
            bnEditMasks_Click(row);
        }

        private void bnEditMasks_Click(int row) {
            if (row >= 0 && row < listeMasks.Count) {
                String mask = listeMasks[row];
                WReadString dialog = new WReadString(this, "Edit a audio-extension", "Mask",mask);
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    mask = dialog.Input;
                    if (!mask.StartsWith(".")) {
                        mask = "." + mask;
                    }
                    listeMasks[row] = mask;
                    listviewMasks.ItemsSource = null; ;
                    listviewMasks.ItemsSource = this.listeMasks;
                }
            }
        }

        private void bnNewMasks_Click(Object sender, RoutedEventArgs e) {
            WReadString dialog = new WReadString(this, "New audio-extension", "Mask", "");
            dialog.ShowDialog();
            if (dialog.Retcode) {
                String mask = dialog.Input;
                if (!mask.StartsWith(".")) {
                    mask = "." + mask;
                }
                listeMasks.Add(mask);
                listviewMasks.ItemsSource = null; ;
                listviewMasks.ItemsSource = this.listeMasks;
            }
        }


        private void bnDeleteMasks_Click(Object sender, RoutedEventArgs e) {
            int row = listviewMasks.SelectedIndex;
            if (row >= 0) {
                listeMasks.RemoveAt(row);
                listviewMasks.ItemsSource = null; ;
                listviewMasks.ItemsSource = this.listeMasks;
            }
        }

        private void bnTopMasks_Click(Object sender, RoutedEventArgs e) {
            int row = listviewMasks.SelectedIndex;
            if (row > 0 && row < listeMasks.Count) {
                String mask = listeMasks[row];
                listeMasks.RemoveAt(row);
                listeMasks.Insert(row - 1, mask);
                listviewMasks.ItemsSource = null; ;
                listviewMasks.ItemsSource = this.listeMasks;                
                listviewMasks.SelectedIndex = row - 1;
            }
        }

        private void bnDownMasks_Click(Object sender, RoutedEventArgs e) {
            int row = listviewMasks.SelectedIndex;
            if (row >= 0 && row < (listeMasks.Count - 1)) {
                String mask = listeMasks[row];
                listeMasks.RemoveAt(row);
                listeMasks.Insert(row + 1, mask);
                listviewMasks.ItemsSource = null; ;
                listviewMasks.ItemsSource = this.listeMasks;
                listviewMasks.SelectedIndex = row + 1;
            }
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (rbSingleClickListView.IsChecked==true) {
                SingVar.ListviewSingleClick = true;
            }
            else {
                SingVar.ListviewSingleClick = false;
            }

            SingVar.listeMasks.Clear();
            foreach (String mask in this.listeMasks) {
                SingVar.listeMasks.Add(mask);
            }
            SingVar.writelisteMasks();

            audioColors.save2Registry();
            //this.audioColors.savefile(Basis.getProgPath() + "dummy.colors");
            //this.audioColorsOri.loadfile(Basis.getProgPath() + "dummy.colors");

            result = true;
            Close();
        }

      

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
           // Basis.writeWindowPosition2Registry(this, SingVar.C_REG_ADR, dialogname);
        }

 
    }
}
