﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace AudioPlayer.Tools {
    /// <summary>
    /// Interaction logic for WRenameFile.xaml
    /// </summary>
    public partial class WRenameFile : Window {
        private String sourcename;
        private bool retcode = false;


        public bool Retcode {
            get { return retcode; }
        }

        public WRenameFile(Window parent, String sourcename) {
            InitializeComponent();
            this.sourcename = sourcename;
           
            this.WindowStartupLocation = System.Windows.WindowStartupLocation.CenterOwner;
            this.Owner = parent;  // Important, because CenterOwner            
        }


        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tOldname.Text = sourcename;
            tNewname.Text = sourcename;
            int i = sourcename.LastIndexOf('.');
            tNewname.Select(0, i);
            tNewname.Focus();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            String newFile = tNewname.Text.Trim();
            if (Basis.CheckFilename(newFile)) {
                if (newFile.Equals(tOldname.Text.Trim())) {
                    Basis.ErrorMsg("The new name must different from the old name", "Info");
                }
                else {
                    retcode = true;
                    Close();
                }
            }
            else {
                Basis.ErrorMsg("The new name are not correct", "Info");
            }
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
                e.Handled = true;
                return;
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                bnEsc_Click(sender, e);
                e.Handled = true;
                return;
            }
        }

    }
}
